#include <avr/pgmspace.h>
#include "font.h"
#include "t6963c.h"


void lcd_print2_p(unsigned char x,unsigned char y, const char *in, const struct FONT_DEF *strcut1, unsigned char invers)
{
	unsigned int offset;
	unsigned char width, by=0, mask=0;
	unsigned char NrBytes;
	unsigned char i,j,map,ertefah;
	unsigned char NewXpos, NewYpos;

    NewXpos = x;

	while((map = pgm_read_byte(in++))) 
	{
		map = pgm_read_byte(&strcut1->mapping_table[map]);

		width = strcut1->glyph_width;
		if(width == 0) width = pgm_read_byte(&strcut1->width_table[map]);

		offset = pgm_read_word(&strcut1->offset_table[map]);
		ertefah = strcut1->glyph_height;

        NrBytes = ((width-1)/8)+1;

		for(j=0; j < ertefah * NrBytes; j+=NrBytes )
		{   // ertefah

			NewYpos = y + j / NrBytes;
			
			for(i=0 ; i<width; i++)
			{   //  width
			    if(i%8 == 0)
			    {
		    	 	by = pgm_read_byte(&strcut1->glyph_table[ offset+j+(i/8) ]);
		     		mask = 0x80;
		    	}

				if( by & mask ) glcd_pixel(  NewXpos + i , NewYpos, !invers  );
 				else            glcd_pixel(  NewXpos + i , NewYpos, invers  );
	 				
 				mask >>= 1;
			}//End i

		}// End j

		NewXpos += width;
	}// End K
}

void lcd_print2(unsigned char x,unsigned char y, const char *in, const struct FONT_DEF *strcut1, unsigned char invers)
{
	unsigned int offset;
	unsigned char width, by=0, mask=0;
	unsigned char NrBytes;
	unsigned char i,j,map,ertefah;
	unsigned char NewXpos, NewYpos;

    NewXpos = x;

	while((map = *in++)) 
	{
		map = pgm_read_byte(&strcut1->mapping_table[map]);

		width = strcut1->glyph_width;
		if(width == 0)
			width = pgm_read_byte(&strcut1->width_table[map]);

		offset = pgm_read_word(&strcut1->offset_table[map]);
		ertefah = strcut1->glyph_height;

        NrBytes = ((width-1)/8)+1;
	
		for(j=0; j<ertefah * NrBytes; j+=NrBytes    )
		{   // ertefah

			NewYpos = y + j / NrBytes;

			for(i=0 ; i<width  ; i++)
			{   //  width
			    if(i%8 == 0)
			    {
			     by = pgm_read_byte(&strcut1->glyph_table[ offset+j+(i/8) ]);
			     mask = 0x80;
			    }

				if( by & mask ) glcd_pixel(  NewXpos + i , NewYpos, !invers  );
	 			else            glcd_pixel(  NewXpos + i , NewYpos, invers  );

	 			mask >>= 1;
			}//End i
			
		}// End j

		NewXpos += width;
	}// End K
}

